#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <queue>
#include <math.h>

#define int long long
#define forn(i, n) for (int i = 0; i < n; i++)
#define pb push_back
#define ld long double
#define x first
#define y second

using namespace std;

float distance(ld x1, ld y1, ld x2, ld y2) {
    return sqrt(pow((x1 - x2), 2) + pow((y1 - y2), 2));
}

signed main() {
    int n;
    ld ans = 0;
    cin >> n;

    vector<pair<ld, ld>> v(n);

    forn(i, n) cin >> v[i].first >> v[i].second;

    for (int i = 0; i < n - 2; i++) {
        for (int j = 0; j < n - 1; j++) {
            for (int k = 0; k < n; k++) {
                if (distance(v[i].x, v[i].y, v[j].x, v[j].y) + distance(v[j].x, v[j].y, v[k].x, v[k].y) >
                    distance(v[i].x, v[i].y, v[j].x, v[j].y) + distance(v[i].x, v[i].y, v[k].x, v[k].y)) {
                    pair<ld, ld> cur = v[j];
                    v[j] = v[i];
                    v[i] = cur;
                }
            }
        }
    }

    for (int i = 1; i < n; i++) {
        ans += distance(v[i - 1].first, v[i - 1].second, v[i].first, v[i].second);
    }

    cout << ans;
}